<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbstractDocumentHolder StructType
 * @subpackage Structs
 */
abstract class AbstractDocumentHolder extends PWObject
{
    /**
     * The documents
     * Meta information extracted from the WSDL
     * - arrayType: tns1:Document[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\Document[]
     */
    public $documents;
    /**
     * The notes
     * Meta information extracted from the WSDL
     * - arrayType: tns1:Note[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\Note[]
     */
    public $notes;
    /**
     * Constructor method for AbstractDocumentHolder
     * @uses AbstractDocumentHolder::setDocuments()
     * @uses AbstractDocumentHolder::setNotes()
     * @param \StructType\Document[] $documents
     * @param \StructType\Note[] $notes
     */
    public function __construct(array $documents = array(), array $notes = array())
    {
        $this
            ->setDocuments($documents)
            ->setNotes($notes);
    }
    /**
     * Get documents value
     * @return \StructType\Document[]|null
     */
    public function getDocuments()
    {
        return $this->documents;
    }
    /**
     * This method is responsible for validating the values passed to the setDocuments method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDocuments method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDocumentsForArrayConstraintsFromSetDocuments(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $abstractDocumentHolderDocumentsItem) {
            // validation for constraint: itemType
            if (!$abstractDocumentHolderDocumentsItem instanceof \StructType\Document) {
                $invalidValues[] = is_object($abstractDocumentHolderDocumentsItem) ? get_class($abstractDocumentHolderDocumentsItem) : sprintf('%s(%s)', gettype($abstractDocumentHolderDocumentsItem), var_export($abstractDocumentHolderDocumentsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The documents property can only contain items of type \StructType\Document, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set documents value
     * @throws \InvalidArgumentException
     * @param \StructType\Document[] $documents
     * @return \StructType\AbstractDocumentHolder
     */
    public function setDocuments(array $documents = array())
    {
        // validation for constraint: array
        if ('' !== ($documentsArrayErrorMessage = self::validateDocumentsForArrayConstraintsFromSetDocuments($documents))) {
            throw new \InvalidArgumentException($documentsArrayErrorMessage, __LINE__);
        }
        $this->documents = $documents;
        return $this;
    }
    /**
     * Add item to documents value
     * @throws \InvalidArgumentException
     * @param \StructType\Document $item
     * @return \StructType\AbstractDocumentHolder
     */
    public function addToDocuments(\StructType\Document $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Document) {
            throw new \InvalidArgumentException(sprintf('The documents property can only contain items of type \StructType\Document, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->documents[] = $item;
        return $this;
    }
    /**
     * Get notes value
     * @return \StructType\Note[]|null
     */
    public function getNotes()
    {
        return $this->notes;
    }
    /**
     * This method is responsible for validating the values passed to the setNotes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNotes method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNotesForArrayConstraintsFromSetNotes(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $abstractDocumentHolderNotesItem) {
            // validation for constraint: itemType
            if (!$abstractDocumentHolderNotesItem instanceof \StructType\Note) {
                $invalidValues[] = is_object($abstractDocumentHolderNotesItem) ? get_class($abstractDocumentHolderNotesItem) : sprintf('%s(%s)', gettype($abstractDocumentHolderNotesItem), var_export($abstractDocumentHolderNotesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The notes property can only contain items of type \StructType\Note, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set notes value
     * @throws \InvalidArgumentException
     * @param \StructType\Note[] $notes
     * @return \StructType\AbstractDocumentHolder
     */
    public function setNotes(array $notes = array())
    {
        // validation for constraint: array
        if ('' !== ($notesArrayErrorMessage = self::validateNotesForArrayConstraintsFromSetNotes($notes))) {
            throw new \InvalidArgumentException($notesArrayErrorMessage, __LINE__);
        }
        $this->notes = $notes;
        return $this;
    }
    /**
     * Add item to notes value
     * @throws \InvalidArgumentException
     * @param \StructType\Note $item
     * @return \StructType\AbstractDocumentHolder
     */
    public function addToNotes(\StructType\Note $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Note) {
            throw new \InvalidArgumentException(sprintf('The notes property can only contain items of type \StructType\Note, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->notes[] = $item;
        return $this;
    }
}
