<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Portfolio StructType
 * @subpackage Structs
 */
class Portfolio extends AbstractDocumentHolder
{
    /**
     * The abbreviation
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $abbreviation;
    /**
     * The active
     * @var bool
     */
    public $active;
    /**
     * The customFields
     * Meta information extracted from the WSDL
     * - arrayType: tns1:CustomField[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\CustomField[]
     */
    public $customFields;
    /**
     * The defaultBankAccount
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Bank
     */
    public $defaultBankAccount;
    /**
     * The defaultSecurityDepositBankAccount
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Bank
     */
    public $defaultSecurityDepositBankAccount;
    /**
     * The managementCompany
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var bool
     */
    public $managementCompany;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The owners
     * Meta information extracted from the WSDL
     * - arrayType: xsd:anyType[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var mixed[]
     */
    public $owners;
    /**
     * The targetOperatingReserve
     * @var float
     */
    public $targetOperatingReserve;
    /**
     * Constructor method for Portfolio
     * @uses Portfolio::setAbbreviation()
     * @uses Portfolio::setActive()
     * @uses Portfolio::setCustomFields()
     * @uses Portfolio::setDefaultBankAccount()
     * @uses Portfolio::setDefaultSecurityDepositBankAccount()
     * @uses Portfolio::setManagementCompany()
     * @uses Portfolio::setName()
     * @uses Portfolio::setOwners()
     * @uses Portfolio::setTargetOperatingReserve()
     * @param string $abbreviation
     * @param bool $active
     * @param \StructType\CustomField[] $customFields
     * @param \StructType\Bank $defaultBankAccount
     * @param \StructType\Bank $defaultSecurityDepositBankAccount
     * @param bool $managementCompany
     * @param string $name
     * @param mixed[] $owners
     * @param float $targetOperatingReserve
     */
    public function __construct($abbreviation = null, $active = null, array $customFields = array(), \StructType\Bank $defaultBankAccount = null, \StructType\Bank $defaultSecurityDepositBankAccount = null, $managementCompany = null, $name = null, array $owners = array(), $targetOperatingReserve = null)
    {
        $this
            ->setAbbreviation($abbreviation)
            ->setActive($active)
            ->setCustomFields($customFields)
            ->setDefaultBankAccount($defaultBankAccount)
            ->setDefaultSecurityDepositBankAccount($defaultSecurityDepositBankAccount)
            ->setManagementCompany($managementCompany)
            ->setName($name)
            ->setOwners($owners)
            ->setTargetOperatingReserve($targetOperatingReserve);
    }
    /**
     * Get abbreviation value
     * @return string|null
     */
    public function getAbbreviation()
    {
        return $this->abbreviation;
    }
    /**
     * Set abbreviation value
     * @param string $abbreviation
     * @return \StructType\Portfolio
     */
    public function setAbbreviation($abbreviation = null)
    {
        // validation for constraint: string
        if (!is_null($abbreviation) && !is_string($abbreviation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($abbreviation, true), gettype($abbreviation)), __LINE__);
        }
        $this->abbreviation = $abbreviation;
        return $this;
    }
    /**
     * Get active value
     * @return bool|null
     */
    public function getActive()
    {
        return $this->active;
    }
    /**
     * Set active value
     * @param bool $active
     * @return \StructType\Portfolio
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        $this->active = $active;
        return $this;
    }
    /**
     * Get customFields value
     * @return \StructType\CustomField[]|null
     */
    public function getCustomFields()
    {
        return $this->customFields;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomFields method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomFields method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomFieldsForArrayConstraintsFromSetCustomFields(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $portfolioCustomFieldsItem) {
            // validation for constraint: itemType
            if (!$portfolioCustomFieldsItem instanceof \StructType\CustomField) {
                $invalidValues[] = is_object($portfolioCustomFieldsItem) ? get_class($portfolioCustomFieldsItem) : sprintf('%s(%s)', gettype($portfolioCustomFieldsItem), var_export($portfolioCustomFieldsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customFields property can only contain items of type \StructType\CustomField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customFields value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomField[] $customFields
     * @return \StructType\Portfolio
     */
    public function setCustomFields(array $customFields = array())
    {
        // validation for constraint: array
        if ('' !== ($customFieldsArrayErrorMessage = self::validateCustomFieldsForArrayConstraintsFromSetCustomFields($customFields))) {
            throw new \InvalidArgumentException($customFieldsArrayErrorMessage, __LINE__);
        }
        $this->customFields = $customFields;
        return $this;
    }
    /**
     * Add item to customFields value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomField $item
     * @return \StructType\Portfolio
     */
    public function addToCustomFields(\StructType\CustomField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomField) {
            throw new \InvalidArgumentException(sprintf('The customFields property can only contain items of type \StructType\CustomField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customFields[] = $item;
        return $this;
    }
    /**
     * Get defaultBankAccount value
     * @return \StructType\Bank|null
     */
    public function getDefaultBankAccount()
    {
        return $this->defaultBankAccount;
    }
    /**
     * Set defaultBankAccount value
     * @param \StructType\Bank $defaultBankAccount
     * @return \StructType\Portfolio
     */
    public function setDefaultBankAccount(\StructType\Bank $defaultBankAccount = null)
    {
        $this->defaultBankAccount = $defaultBankAccount;
        return $this;
    }
    /**
     * Get defaultSecurityDepositBankAccount value
     * @return \StructType\Bank|null
     */
    public function getDefaultSecurityDepositBankAccount()
    {
        return $this->defaultSecurityDepositBankAccount;
    }
    /**
     * Set defaultSecurityDepositBankAccount value
     * @param \StructType\Bank $defaultSecurityDepositBankAccount
     * @return \StructType\Portfolio
     */
    public function setDefaultSecurityDepositBankAccount(\StructType\Bank $defaultSecurityDepositBankAccount = null)
    {
        $this->defaultSecurityDepositBankAccount = $defaultSecurityDepositBankAccount;
        return $this;
    }
    /**
     * Get managementCompany value
     * @return bool|null
     */
    public function getManagementCompany()
    {
        return $this->managementCompany;
    }
    /**
     * Set managementCompany value
     * @param bool $managementCompany
     * @return \StructType\Portfolio
     */
    public function setManagementCompany($managementCompany = null)
    {
        // validation for constraint: boolean
        if (!is_null($managementCompany) && !is_bool($managementCompany)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($managementCompany, true), gettype($managementCompany)), __LINE__);
        }
        $this->managementCompany = $managementCompany;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\Portfolio
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get owners value
     * @return mixed[]|null
     */
    public function getOwners()
    {
        return $this->owners;
    }
    /**
     * This method is responsible for validating the values passed to the setOwners method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOwners method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOwnersForArrayConstraintsFromSetOwners(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $portfolioOwnersItem) {
            // validation for constraint: itemType
            if (false) {
                $invalidValues[] = is_object($portfolioOwnersItem) ? get_class($portfolioOwnersItem) : sprintf('%s(%s)', gettype($portfolioOwnersItem), var_export($portfolioOwnersItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The owners property can only contain items of type anyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set owners value
     * @throws \InvalidArgumentException
     * @param mixed[] $owners
     * @return \StructType\Portfolio
     */
    public function setOwners(array $owners = array())
    {
        // validation for constraint: array
        if ('' !== ($ownersArrayErrorMessage = self::validateOwnersForArrayConstraintsFromSetOwners($owners))) {
            throw new \InvalidArgumentException($ownersArrayErrorMessage, __LINE__);
        }
        $this->owners = $owners;
        return $this;
    }
    /**
     * Add item to owners value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\Portfolio
     */
    public function addToOwners($item)
    {
        // validation for constraint: itemType
        if (false) {
            throw new \InvalidArgumentException(sprintf('The owners property can only contain items of type anyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->owners[] = $item;
        return $this;
    }
    /**
     * Get targetOperatingReserve value
     * @return float|null
     */
    public function getTargetOperatingReserve()
    {
        return $this->targetOperatingReserve;
    }
    /**
     * Set targetOperatingReserve value
     * @param float $targetOperatingReserve
     * @return \StructType\Portfolio
     */
    public function setTargetOperatingReserve($targetOperatingReserve = null)
    {
        // validation for constraint: float
        if (!is_null($targetOperatingReserve) && !(is_float($targetOperatingReserve) || is_numeric($targetOperatingReserve))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($targetOperatingReserve, true), gettype($targetOperatingReserve)), __LINE__);
        }
        $this->targetOperatingReserve = $targetOperatingReserve;
        return $this;
    }
}
