<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdatePayment StructType
 * @subpackage Structs
 */
class UpdatePayment extends AbstractStructBase
{
    /**
     * The batchDate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $batchDate;
    /**
     * The batchID
     * @var int
     */
    public $batchID;
    /**
     * The comments
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $comments;
    /**
     * The nsfBatchDate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $nsfBatchDate;
    /**
     * The nsfBatchID
     * @var int
     */
    public $nsfBatchID;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $status;
    /**
     * The txnID
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $txnID;
    /**
     * Constructor method for UpdatePayment
     * @uses UpdatePayment::setBatchDate()
     * @uses UpdatePayment::setBatchID()
     * @uses UpdatePayment::setComments()
     * @uses UpdatePayment::setNsfBatchDate()
     * @uses UpdatePayment::setNsfBatchID()
     * @uses UpdatePayment::setStatus()
     * @uses UpdatePayment::setTxnID()
     * @param string $batchDate
     * @param int $batchID
     * @param string $comments
     * @param string $nsfBatchDate
     * @param int $nsfBatchID
     * @param string $status
     * @param string $txnID
     */
    public function __construct($batchDate = null, $batchID = null, $comments = null, $nsfBatchDate = null, $nsfBatchID = null, $status = null, $txnID = null)
    {
        $this
            ->setBatchDate($batchDate)
            ->setBatchID($batchID)
            ->setComments($comments)
            ->setNsfBatchDate($nsfBatchDate)
            ->setNsfBatchID($nsfBatchID)
            ->setStatus($status)
            ->setTxnID($txnID);
    }
    /**
     * Get batchDate value
     * @return string|null
     */
    public function getBatchDate()
    {
        return $this->batchDate;
    }
    /**
     * Set batchDate value
     * @param string $batchDate
     * @return \StructType\UpdatePayment
     */
    public function setBatchDate($batchDate = null)
    {
        // validation for constraint: string
        if (!is_null($batchDate) && !is_string($batchDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($batchDate, true), gettype($batchDate)), __LINE__);
        }
        $this->batchDate = $batchDate;
        return $this;
    }
    /**
     * Get batchID value
     * @return int|null
     */
    public function getBatchID()
    {
        return $this->batchID;
    }
    /**
     * Set batchID value
     * @param int $batchID
     * @return \StructType\UpdatePayment
     */
    public function setBatchID($batchID = null)
    {
        // validation for constraint: int
        if (!is_null($batchID) && !(is_int($batchID) || ctype_digit($batchID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($batchID, true), gettype($batchID)), __LINE__);
        }
        $this->batchID = $batchID;
        return $this;
    }
    /**
     * Get comments value
     * @return string|null
     */
    public function getComments()
    {
        return $this->comments;
    }
    /**
     * Set comments value
     * @param string $comments
     * @return \StructType\UpdatePayment
     */
    public function setComments($comments = null)
    {
        // validation for constraint: string
        if (!is_null($comments) && !is_string($comments)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comments, true), gettype($comments)), __LINE__);
        }
        $this->comments = $comments;
        return $this;
    }
    /**
     * Get nsfBatchDate value
     * @return string|null
     */
    public function getNsfBatchDate()
    {
        return $this->nsfBatchDate;
    }
    /**
     * Set nsfBatchDate value
     * @param string $nsfBatchDate
     * @return \StructType\UpdatePayment
     */
    public function setNsfBatchDate($nsfBatchDate = null)
    {
        // validation for constraint: string
        if (!is_null($nsfBatchDate) && !is_string($nsfBatchDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nsfBatchDate, true), gettype($nsfBatchDate)), __LINE__);
        }
        $this->nsfBatchDate = $nsfBatchDate;
        return $this;
    }
    /**
     * Get nsfBatchID value
     * @return int|null
     */
    public function getNsfBatchID()
    {
        return $this->nsfBatchID;
    }
    /**
     * Set nsfBatchID value
     * @param int $nsfBatchID
     * @return \StructType\UpdatePayment
     */
    public function setNsfBatchID($nsfBatchID = null)
    {
        // validation for constraint: int
        if (!is_null($nsfBatchID) && !(is_int($nsfBatchID) || ctype_digit($nsfBatchID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nsfBatchID, true), gettype($nsfBatchID)), __LINE__);
        }
        $this->nsfBatchID = $nsfBatchID;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\UpdatePayment
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get txnID value
     * @return string|null
     */
    public function getTxnID()
    {
        return $this->txnID;
    }
    /**
     * Set txnID value
     * @param string $txnID
     * @return \StructType\UpdatePayment
     */
    public function setTxnID($txnID = null)
    {
        // validation for constraint: string
        if (!is_null($txnID) && !is_string($txnID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($txnID, true), gettype($txnID)), __LINE__);
        }
        $this->txnID = $txnID;
        return $this;
    }
}
